//Sample using LiquidCrystal library 
#include <LiquidCrystal.h> 
#include <OneWire.h>          // для обмена по 1-wire
#include <EEPROM.h>           // для работы с EEPROM 

byte data[9];               // массив для хранения данных принятых от датчика
byte TotalDS=0;             // число найденых датчиков на линии
byte addr[4][8] = {         // двумерный массив адресов датчиков
  {
    0,0,0,0,0,0,0,0    }
  ,       // 4 адреса по 8 байт
  {
    0,0,0,0,0,0,0,0    }
  ,
  {
    0,0,0,0,0,0,0,0    }
  ,
  {
    0,0,0,0,0,0,0,0    }
  ,
};  
/******************** из другой программы************************/
int butval[8]={
  0,1023,817,602,407,203,0,0};   // АЦП кнопок
byte butPin = 0;            // пин входа кнопок
byte i;                     // просто счетчик
int val;                    // знач. АЦП при нажатой кнопке
byte n;                     // просто счетчик
byte butPush = 0;           // код нажатой кнопки
byte butsens=20;            // чувствительность кнопок
byte buzzer = 3;            // выход динамика
boolean butRel=1;           // отпущена ли сейчас кнопка


/********************************************/
OneWire  ds(2);             // на этот пин подключена линия DQ 1-wire 

// select the pins used on the LCD panel 
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);  
// define some values used by the panel and buttons
int lcd_key     = 0; 
int adc_key_in  = 0;
#define btnRIGHT  0 
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5   
// read the buttons 
int read_LCD_buttons()
{ 
  adc_key_in = analogRead(0);  // read the value from the sensor   
  // my buttons when read are centered at these valies: 0, 144, 329, 504, 741  
  // we add approx 50 to those values and check to see if we are close  
  if (adc_key_in > 1000) return btnNONE; // We make this the 1st option for speed reasons since it will be the most likely result 
  if (adc_key_in < 50)   return btnRIGHT; 
  if (adc_key_in < 195)  return btnUP;   
  if (adc_key_in < 380)  return btnDOWN;
  if (adc_key_in < 555)  return btnLEFT; 
  if (adc_key_in < 790)  return btnSELECT;   
  return btnNONE;  // when all others fail, return this... 
}
void setup() {  
  lcd.begin(16, 2);              // start the library  lcd.setCursor(0,0);
  lcd.print("Push the buttons"); // print a simple message
  if (analogRead(adc_key_in) < 1000) {    // если в момент загрузки значение АЦП
    // ... клавиатуры больше 100 (нажата какая-то кнопка) то запускаем процедуру калибровки
    lcd.print("Kalibrate");         // На дисплей выводим слово "Калибровка"
    lcd.setCursor(0,1);              // устанавливаем курсор во вторую строку
    delay(3000);                     // пауза 3 сек, за это время надо отпустить кнопку
    for ( i = 1; i < 6; i++) {       // цикл от 1 до 5
      lcd.clear();                     // очищаем дисплей
      lcd.print("Press ");           // выводим слово "Нажмите" с пробелом в конце в первую строку
      lcd.print(i, DEC);               // выводим номер кнопки, теперь на экране написано "Нажмите 1"
      while (analogRead(butPin) > 1000) {
      }; //ничего не делаем (пустой цикл) пока не нажата кнопка
       button ();                       // процедура опроса кнопки, по окончанию в val будет значение АЦП
      butval[i]=val;                   // записываем это значение в массив
      lcd.clear();                     // очищаем дисплей
      lcd.setCursor(0,1);              // и во вторую строку ...
      lcd.print(i, DEC);               // ... выводим номер кнопки ...
      lcd.print(" ");                  // ... и через пробел...
      lcd.print(butval[i], DEC);       // значение АЦРП ей соответствующее
      EEPROM.write(224+i*2,butval[i]/4); // записиваем в EEPROM по 2 байта на значение начиная с адреса 224
      // в первый адрес старшие 8 бит
      EEPROM.write(225+i*2,butval[i]%4); // во второй - остаток. (всего у нас было 10 бит)
      delay(1000);                       // пауза 1 сек (просто так... чтоб сильно не шокировать)
    }
  } // конец калибровки
  else { // читаем АЦП кнопок         // если условие запуска калибровки не выполнилось читаем то, что было записано ранее
    for ( i = 0; i < 8; i++) {        // цикл на 8 байт. опять же пережиток
      butval[i] = EEPROM.read(224+i*2)*4+EEPROM.read(225+i*2);  //процедура обратная записию берем старшие 8 бит, 
      // ... сдвигаем на 2 разряда (умножаем на 4) и прибавляем младшие биты.
    } // конец цикла
  } // конец if 
  read_DS();  //считываем адреса датчиков из памяти, подпрограмма ниже
} // конец setup   

byte read_DS() {               // программа считывает адреса датчиков из памяти
  for (n=0; n<4; n++) {        // у нас она "заточена" на 4 адреса, потому и цикл до 4
    for (i=0; i<8; i++) {      // в адресе 8 байт
      addr[n][i] = EEPROM.read(128+n*8+i); // читаем байт со смещением 128 + 8 * номер датчика + номер байта
    }
  }
  return 0;
}

int button () {                // подпрограмма считывания кнопок
    int exitMenu = 1;          // если exitMenu истина то выходим из меню
    butPush = 0;               // код нажатой кнопки
    delay(15);                 // задержка для устранения дребезга контактов
    val = analogRead(butPin);  // читаем АЦП порта кнопок (значение от 0 до 1023)
    if (val > (butval[5]-butsens) && val < (butval[5]+butsens)) {butPush = 5;}  // если считанное значение около (на величину butsens)
    // значения соответствующего кнопке 5 то считаем что она и нажата
    if (val > (butval[4]-butsens) && val < (butval[4]+butsens)) {butPush = 4;}  // аналогично для остальных
    if (val > (butval[3]-butsens) && val < (butval[3]+butsens)) {butPush = 3;}
    if (val > (butval[2]-butsens) && val < (butval[2]+butsens)) {butPush = 2;}
    if (val > (butval[1]-butsens) && val < (butval[1]+butsens)) {butPush = 1;}
//    if (val < (butval[1]+butsens)) {butPush = 1;}     
    // коды кнопок: 1 - вверх, 2 - влево, 3 - ок, 4 - вправо, 5 вниз 
    butRel=0;                  // эта переменная нужна для проверки в главной программе
    return butPush;            // возвращаем значение нажатой кнопки
}

byte write_DS() {              // программа записывает адреса датчиков в память
 // for (i=0; i<8; i++) {        // всего 8 байт. В переменной m - номер датчика который надо записать
 //   if (m==0) {EEPROM.write(128+t*8+i,0);} // записывать будем начиная с адреса 128. Если номер датчика равен нулю - то значит он отсутствует.
  //  else {EEPROM.write(128+t*8+i,addr[m-1][i]);}
 //   }
 // return 0;
}
//----------------------------------------------------------*---------------
void loop() 
{  
  lcd.setCursor(9,1); // move cursor to second line "1" and 9 spaces over 
  lcd.print(millis()/1000);// display seconds elapsed since power-up 
  lcd.setCursor(0,1); // move to the begining of the second line 
  lcd_key = read_LCD_buttons(); // read the buttons   
  lcd.print(adc_key_in); 
  switch (lcd_key)       // depending on which button was pushed, we perform an action            
   { 
    case btnRIGHT:         lcd.print("RIGHT ");     break;         
    case btnLEFT:          lcd.print("LEFT   ");  break;     
    case btnUP:            lcd.print("UP    ");        break;      
    case btnDOWN:            lcd.print("DOWN  ");           break;      
    case btnSELECT:            lcd.print("SELECT");         break;         
    case btnNONE:            lcd.print("NONE  ");         break;      
  }   
};
//----------------------------------------------------------*---------------




